---
title: operator
slug: Web/SVG/Attribute/operator
tags:
  - Filters
  - NeedsCompatTable
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>operator</code></strong> attribute has two meanings based on the context itʼs used in. Either it defines the compositing or morphing operation to be performed.</p>

<p>Two elements are using this attribute: {{SVGElement("feComposite")}} and {{SVGElement("feMorphology")}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css notranslate">html, body, svg {
  height: 100%;
  font: 20px Arial, Helvetica, sans-serif;
}</pre>
</div>

<pre class="brush: html; highlight[3,6] notranslate">&lt;svg viewBox="0 0 120 70" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;filter id="erode"&gt;
    &lt;feMorphology operator="erode" radius="0.4"/&gt;
  &lt;/filter&gt;
  &lt;filter id="dilate"&gt;
    &lt;feMorphology operator="dilate" radius="0.8"/&gt;
  &lt;/filter&gt;

  &lt;text x="0" y="15"&gt;Normal text&lt;/text&gt;
  &lt;text x="0" y="40" filter="url(#erode)"&gt;Thin text&lt;/text&gt;
  &lt;text x="0" y="65" filter="url(#dilate)"&gt;Fat text&lt;/text&gt;
&lt;/svg&gt;
</pre>
</div>

<p>{{EmbedLiveSample("topExample", "240", "200")}}</p>

<h2 id="feComposite">feComposite</h2>

<p>For {{SVGElement("feComposite")}}, <code>operator</code> defines the compositing operation that is to be performed.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>over</code> | <code>in</code> | <code>out</code> | <code>atop</code> | <code>xor</code> | <code>lighter</code> | <code>arithmetic</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>over</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>over</code></dt>
 <dd>This value indicates that the source graphic defined in the {{SVGAttr("in")}} attribute is placed over the destination graphic defined in the {{SVGAttr("in2")}} attribute.</dd>
 <dt><code>in</code></dt>
 <dd>This value indicates that the parts of the source graphic defined in the <code>in</code> attribute that overlap the destination graphic defined in the <code>in2</code> attribute, replace the destination graphic.</dd>
 <dt><code>out</code></dt>
 <dd>This value indicates that the parts of the source graphic defined in the <code>in</code> attribute that fall outside the destination graphic defined in the <code>in2</code> attribute, are displayed.</dd>
 <dt><code>atop</code></dt>
 <dd>
 <p>This value indicates that the parts of the source graphic defined in the <code>in</code> attribute, which overlap the destination graphic defined in the <code>in2</code> attribute, replace the destination graphic. The parts of the destination graphic that do not overlap with the source graphic stay untouched.</p>
 </dd>
 <dt><code>xor</code></dt>
 <dd>This value indicates that the non-overlapping regions of the source graphic defined in the <code>in</code> attribute and the destination graphic defined in the <code>in2</code> attribute are combined.</dd>
 <dt><code>lighter</code></dt>
 <dd>This value indicates that the sum of the source graphic defined in the <code>in</code> attribute and the destination graphic defined in the <code>in2</code> attribute is displayed.</dd>
 <dt><code>arithmetic</code></dt>
 <dd>
 <p>This value indicates that the source graphic defined in the <code>in</code> attribute and the destination graphic defined in the <code>in2</code> attribute are combined using the following formula:</p>

 <p><code>result = k1*i1*i2 + k2*i1 + k3*i2 + k4</code></p>

 <p>where:<br>
  <code>i1</code> and <code>i2</code> indicate the corresponding pixel channel values of the input image, which map to <code>in</code> and <code>in2</code> respectively, and {{SVGAttr("k1")}},{{SVGAttr("k2")}},{{SVGAttr("k3")}},and {{SVGAttr("k4")}} indicate the values of the attributes with the same name.</p>
 </dd>
</dl>

<h2 id="feMorphology">feMorphology</h2>

<p>For {{SVGElement("feMorphology")}}, <code>operator</code> defines whether to erode (i.e., thin) or dilate (fatten) the source graphic.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>erode</code> | <code>dilate</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>erode</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<dl>
 <dt><code>erode</code></dt>
 <dd>This value thins the source graphic defined in the {{SVGAttr("in")}} attribute.</dd>
 <dt><code>dilate</code></dt>
 <dd>This value fattens the source graphic defined in the <code>in</code> attribute.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Filters 1.0", "#element-attrdef-femorphology-operator", "operator for &lt;feMorphology&gt;")}}</td>
   <td>{{Spec2("Filters 1.0")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("Filters 1.0", "#element-attrdef-fecomposite-operator", "operator for &lt;feComposite&gt;")}}</td>
   <td>{{Spec2("Filters 1.0")}}</td>
   <td>Refers to CSS Compositing and Blending specification for the values and added the <code>lighter</code> value.</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "filters.html#feMorphologyOperatorAttribute", "operator for &lt;feMorphology&gt;")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition for <code>&lt;feMorphology&gt;</code></td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "filters.html#feCompositeOperatorAttribute", "operator for &lt;feComposite&gt;")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition for <code>&lt;feComposite&gt;</code></td>
  </tr>
 </tbody>
</table>
